package test;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.faces.context.FacesContext;

import org.ajax4jsf.model.DataVisitor;
import org.ajax4jsf.model.ExtendedDataModel;
import org.ajax4jsf.model.Range;
import org.richfaces.model.FilterField;
import org.richfaces.model.Modifiable;
import org.richfaces.model.SortField2;

public class ObjectTableModel extends ExtendedDataModel implements Modifiable {
	protected RowData dataItem = null;
	protected int rowCount = 10;
	protected List<RowData> cachedItems;
	protected String tableState;
	protected List<String> propertyNames = null;
	private String filterName;
	protected Map<String, String> filterMap = null;


    public ObjectTableModel() {
    	propertyNames = new ArrayList<String>();
    	propertyNames.add("ID");
    	propertyNames.add("Name");
    	propertyNames.add("Type");    	
    	filterMap = new HashMap<String, String>();
    	filterMap.put("ID", "ID Filter");
    	filterMap.put("Name", "Name Filter");
    	filterMap.put("Type", "Type Filter");
    }

	public List<RowData> getCachedItems() {
		return cachedItems;
	}
	
	public void setCachedItems(List<RowData> cachedItems) {
		this.cachedItems = cachedItems;
	}
	
	public String getTableState() {
		return tableState;
	}

	public void setTableState(String tableState) {
		this.tableState = tableState;
	}

	@Override
    public Object getRowKey() {
        return this.dataItem;
    }

    @Override
    public void setRowKey(Object key) {
   		this.dataItem = (RowData) key;
    }

    @Override
    public int getRowCount() {
        return this.rowCount;
    }

    @Override
    public Object getRowData() {
        return this.dataItem;
    }

    @Override
    public int getRowIndex() {
        return -1;
    }

    @Override
    public Object getWrappedData() {
        return null;
    }

    @Override
    public boolean isRowAvailable() {
        return (this.dataItem != null);
    }

    @Override
    public void setRowIndex(int rowIndex) {
    }

    @Override
    public void setWrappedData(Object data) {
    }
    
	
	public void modify(List<FilterField> filterFields, List<SortField2> sortFields) {
    }

    public List<String> getPropertyNames() {
		return propertyNames;
	}

	public void setPropertyNames(List<String> propertyNames) {
		this.propertyNames = propertyNames;
	}

    public RowData getDataItem() {
		return dataItem;
	}

	public void setDataItem(RowData dataItem) {
		this.dataItem = dataItem;
	}

	public String getFilterName() {
		return filterName;
	}

	public void setFilterName(String filterName) {
		this.filterName = filterName;
		System.out.println("The filter name is set to " + this.filterName);
	}

	public void setRowCount(int rowCount) {
		this.rowCount = rowCount;
	}

	public Map<String, String> getFilterMap() {
		return filterMap;
	}

	public void setFilterMap(Map<String, String> filterMap) {
		this.filterMap = filterMap;
	}

	public void walk(FacesContext facesContext, DataVisitor visitor, Range range,
        Object argument) throws IOException {
		this.cachedItems = new ArrayList<RowData>();
		for (int i = 0; i < 10; i++) {
            this.cachedItems.add(new RowData(i));
		}
     
        for (RowData item: cachedItems) {
            visitor.process(facesContext, item, argument);
        }		
    }


    public class RowData {
    	HashMap<String, String> map = null;
    	
    	public RowData(int i) {
    		this.map = new HashMap<String, String>();
    		this.map.put("ID", "id-" + i);
    		this.map.put("Name", "name-" + i);
    		this.map.put("Type", "type-" + i);
    	}

		public HashMap<String, String> getMap() {
			return map;
		}

		public void setMap(HashMap<String, String> map) {
			this.map = map;
		}
    }
}


